/*
 *	Set UniCode Screen Output Mapping Table
 *
 *	(c) 1997 Martin Mares <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linux/kd.h>

unsigned short table[256];

int
main(void)
{
  char buf[256];
  int i, j;

  while (fgets(buf, 256, stdin))
	{
	  char *c = strchr(buf, '\n');
	  if (c)
		*c = 0;
	  if (!buf || *buf == '#')
		continue;
	  if (sscanf(buf, "%x%x", &i, &j) != 2)
		{
		  fprintf(stderr, "Table syntax error!\n");
		  return 1;
		}
	  if (i < 0 || i > 255)
		{
		  fprintf(stderr, "Character code out of range!\n");
		  return 1;
		}
	  if (j < 0 || j > 65535)
		{
		  fprintf(stderr, "Glyph code out of range!\n");
		  return 1;
		}
	  table[i] = j;
	}

  if (ioctl(1, PIO_UNISCRNMAP, table))
	{
	  fprintf(stderr, "PIO_UNISCRNMAP: %m\n");
	  return 1;
	}

  return 0;
}
